/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.DispositivoEmbarcada;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.enums.SistemaEnum;
import com.rjconsultores.ventaboletos.service.DispositivoEmbarcadaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderOperadorDispositivoVendaEmbarcada;
import com.trg.search.Search;

/**
 *
 * @author Fabricio
 */
@Controller("busquedaDispositivoOperadorVendaEmbarcadaController")
@Scope("prototype")
public class BusquedaDispositivoOperadorVendaEmbarcadaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<DispositivoEmbarcada> plwDispositivoVendaEmbarcada;
	private MyComboboxEstandar cmbEmpresa;
	private List<Empresa> lsEmpresa;
	private List<SistemaEnum> lsSistemaEnum;
	private MyComboboxPuntoVenta cmbPuntoVenta;
	private Textbox txtDescricao;
	private Textbox txtRegistro;
	private MyComboboxEstandar cmbVersaoUltimaSinc;
	private Textbox txtMei;
	private Paging pagingDispositivoVendaEmbarcada;
	private MyListbox dispositivoVendaEmbarcadaList;
	private Search dispositivoVendaEmbarcadaBusqueda;
	private List<String> lsVersoesDispoitivos;
	@Autowired
	private DispositivoEmbarcadaService dispositivoEmbarcadaService;



	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		this.lsEmpresa = UsuarioLogado.getUsuarioLogado().getEmpresa();
		setLsVersoesDispoitivos(dispositivoEmbarcadaService.buscarAllVersaoUltimaSinc());
		lsSistemaEnum = Arrays.asList(SistemaEnum.values());

		dispositivoVendaEmbarcadaList.setItemRenderer(new RenderOperadorDispositivoVendaEmbarcada());
		dispositivoVendaEmbarcadaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				DispositivoEmbarcada a = (DispositivoEmbarcada) dispositivoVendaEmbarcadaList.getSelected();
				verDispositivoVendaEmbarcada(a);
			}
		});

		refreshLista();

		cmbEmpresa.focus();
	}

	private void verDispositivoVendaEmbarcada(DispositivoEmbarcada a) {
		if (a == null) {
			return;
		}

		Map<String, Object> args = new HashMap<String, Object>();
		args.put("dispositivoVendaEmbarcada", a);
		args.put("dispositivoVendaEmbarcadaList", dispositivoVendaEmbarcadaList);

		openWindow("/gui/esquema_operacional/editarOperadoresDispositivo.zul",
				Labels.getLabel("editarOperadoresDispositivoController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<DispositivoEmbarcada> dispositivoEmbarcadaBusqueda = new HibernateSearchObject<DispositivoEmbarcada>(DispositivoEmbarcada.class,
				pagingDispositivoVendaEmbarcada.getPageSize());

		dispositivoEmbarcadaBusqueda.addFilterLike("descricao",
				"%" + txtDescricao.getText().trim().concat("%"));
		
		dispositivoEmbarcadaBusqueda.addFilterLike("registro",
				"%" + txtRegistro.getText().trim().concat("%"));
		
		
		dispositivoEmbarcadaBusqueda.addFilterLike("imei",
				"%" + txtMei.getText().trim().concat("%"));
		
		Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
        if (cbiEmpresa != null) {
        	Empresa dab = (Empresa) cbiEmpresa.getValue();
            dispositivoEmbarcadaBusqueda.addFilterEqual("empresa.empresaId", dab.getEmpresaId());
        }
        
        Comboitem cbiPuntoVenta = cmbPuntoVenta.getSelectedItem();
        if (cbiPuntoVenta != null) {
        	PuntoVenta dab = (PuntoVenta) cbiPuntoVenta.getValue();
            dispositivoEmbarcadaBusqueda.addFilterEqual("puntoVenta.puntoventaId", dab.getPuntoventaId());
        }

		plwDispositivoVendaEmbarcada.init(dispositivoEmbarcadaBusqueda, dispositivoVendaEmbarcadaList, pagingDispositivoVendaEmbarcada);

		if (dispositivoVendaEmbarcadaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("dispositivoVendaEmbarcadaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}
	
	
	public List<SistemaEnum> getLsSistemaEnum() {
		return lsSistemaEnum;
	}

	public void setLsSistemaEnum(List<SistemaEnum> lsSistemaEnum) {
		this.lsSistemaEnum = lsSistemaEnum;
	}

	public PagedListWrapper<DispositivoEmbarcada> getPlwplwDispositivoVendaEmbarcada() {
		return plwDispositivoVendaEmbarcada;
	}

	public void setPlwDispositivoVendaEmbarcada(PagedListWrapper<DispositivoEmbarcada> plwDispositivoVendaEmbarcada) {
		this.plwDispositivoVendaEmbarcada = plwDispositivoVendaEmbarcada;
	}

	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(MyComboboxEstandar cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public Textbox getTxtDescricao() {
		return txtDescricao;
	}

	public void setTxtDescricao(Textbox txtDescricao) {
		this.txtDescricao = txtDescricao;
	}

	public Textbox getTxtRegistro() {
		return txtRegistro;
	}

	public void setTxtRegistro(Textbox txtRegistro) {
		this.txtRegistro = txtRegistro;
	}


	public Textbox getTxtMei() {
		return txtMei;
	}

	public void setTxtMei(Textbox txtMei) {
		this.txtMei = txtMei;
	}

	public Paging getPagingDispositivoVendaEmbarcada() {
		return pagingDispositivoVendaEmbarcada;
	}

	public void setPagingDispositivoVendaEmbarcada(Paging pagingDispositivoVendaEmbarcada) {
		this.pagingDispositivoVendaEmbarcada = pagingDispositivoVendaEmbarcada;
	}

	public MyListbox getDispositivoVendaEmbarcadaList() {
		return dispositivoVendaEmbarcadaList;
	}

	public void setDispositivoVendaEmbarcadaList(MyListbox dispositivoVendaEmbarcadaList) {
		this.dispositivoVendaEmbarcadaList = dispositivoVendaEmbarcadaList;
	}

	public Search getDispositivoVendaEmbarcadaBusqueda() {
		return dispositivoVendaEmbarcadaBusqueda;
	}

	public void setDispositivoVendaEmbarcadaBusqueda(Search dispositivoVendaEmbarcadaBusqueda) {
		this.dispositivoVendaEmbarcadaBusqueda = dispositivoVendaEmbarcadaBusqueda;
	}

	public PagedListWrapper<DispositivoEmbarcada> getPlwDispositivoVendaEmbarcada() {
		return plwDispositivoVendaEmbarcada;
	}
	
	public MyComboboxEstandar getCmbVersaoUltimaSinc() {
		return cmbVersaoUltimaSinc;
	}

	public void setCmbVersaoUltimaSinc(MyComboboxEstandar cmbVersaoUltimaSinc) {
		this.cmbVersaoUltimaSinc = cmbVersaoUltimaSinc;
	}

	public List<String> getLsVersoesDispoitivos() {
		return lsVersoesDispoitivos;
	}

	public void setLsVersoesDispoitivos(List<String> lsVersoesDispoitivos) {
		this.lsVersoesDispoitivos = lsVersoesDispoitivos;
	}


}
